﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Transactions;

namespace DotNetNote.Business
{
    public class DotNetNoteBiz
    {
        /// <summary>
        /// 데이터 저장 메서드
        /// </summary>
        /// <param name="dnn">DotNetNote 테이블 엔터티 클래스</param>
        public void WriteDotNetNote(DotNetNote.Entity.DotNetNote dnn)
        {
            DotNetNote.Data.DotNetNoteData dnnData = new DotNetNote.Data.DotNetNoteData();
            dnnData.WriteDotNetNote(dnn);
        }

        public List<DotNetNote.Entity.DotNetNote> ListDotNetNote(int intPage)
        {
            // 리스트 제네릭 클래스 형으로 반환
            List<DotNetNote.Entity.DotNetNote> list = new List<DotNetNote.Entity.DotNetNote>();
            // DAC단 호출 : DataSet -> DataTable로 변환
            DotNetNote.Data.DotNetNoteData dnnData = new DotNetNote.Data.DotNetNoteData();
            DataTable dt = dnnData.ListDotNetNote(intPage).Tables[0];
            // 데이터가 있는만큼 반복 : 최대 10개(이미 저장 프로시저에서 처리)
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                DotNetNote.Entity.DotNetNote dnn = new DotNetNote.Entity.DotNetNote();

                dnn.Num = Convert.ToInt32(dt.Rows[i]["Num"]);
                dnn.Name = dt.Rows[i]["Name"].ToString();
                dnn.Title = dt.Rows[i]["Title"].ToString();
                dnn.PostDate = Convert.ToDateTime(dt.Rows[i]["PostDate"]);
                dnn.FileName = dt.Rows[i]["FileName"].ToString();
                dnn.ReadCount = Convert.ToInt32(dt.Rows[i]["ReadCount"]);
                // 나머지 항목도 넣을 것
                dnn.Step = Convert.ToInt32(dt.Rows[i]["Step"]);
                dnn.CommentCount = Convert.ToInt32(dt.Rows[i]["CommentCount"]);

                list.Add(dnn); 
            }                
            // 반환
            return list; 
        }

        /// <summary>
        /// 총 레코드 수 반환
        /// </summary>
        public int GetCountDotNetNote()
        {
            return (new DotNetNote.Data.DotNetNoteData()).GetCountDotNetNote();
        }

        /// <summary>
        /// 검색된 레코드 수 반환
        /// </summary>
        public int GetCountDotNetNoteByWord(string searchField, string searchQuery)
        {
            return (new DotNetNote.Data.DotNetNoteData())
                .GetCountDotNetNoteByWord(searchField, searchQuery);
        }

        public DotNetNote.Entity.DotNetNote ViewDotNetNote(int num)
        {
            // 엔터티 개체 생성
            DotNetNote.Entity.DotNetNote dnn = new DotNetNote.Entity.DotNetNote();

            DotNetNote.Data.DotNetNoteData dnnData = new DotNetNote.Data.DotNetNoteData();
            DataTable dt = dnnData.ViewDotNetNote(num).Tables[0];
            // 데이터가 있는만큼 반복 : 최대 10개(이미 저장 프로시저에서 처리)
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                dnn.Num = Convert.ToInt32(dt.Rows[i]["Num"]);
                dnn.Name = dt.Rows[i]["Name"].ToString();
                dnn.Email = dt.Rows[i]["Email"].ToString();
                dnn.Title = dt.Rows[i]["Title"].ToString();
                dnn.PostDate = Convert.ToDateTime(dt.Rows[i]["PostDate"]);
                dnn.FileName = dt.Rows[i]["FileName"].ToString();
                dnn.ReadCount = Convert.ToInt32(dt.Rows[i]["ReadCount"]);
                dnn.Homepage = dt.Rows[i]["Homepage"].ToString();
                dnn.PostIP = dt.Rows[i]["PostIP"].ToString();
                dnn.Encoding = dt.Rows[i]["Encoding"].ToString();
                dnn.Content = dt.Rows[i]["Content"].ToString();

                dnn.DownCount = Convert.ToInt32(dt.Rows[i]["DownCount"]); // 
            }

            // 반환
            return dnn; 
        }


        /// <summary>
        /// 답변
        /// </summary>
        /// <param name="dnn"></param>
        public void ReplyDotNetNote(DotNetNote.Entity.DotNetNote dnn)
        {
            (new DotNetNote.Data.DotNetNoteData()).ReplyDotNetNote(dnn);         
        }

        /// <summary>
        /// 수정
        /// </summary>
        /// <param name="dnn"></param>
        /// <returns>1이 반환되면 수정되고, 0이 반환되면 암호 잘못?</returns>
        public int ModifyDotNetNote(DotNetNote.Entity.DotNetNote dnn)
        {
            return (new DotNetNote.Data.DotNetNoteData()).ModifyDotNetNote(dnn); 
        }

        /// <summary>
        /// 삭제
        /// </summary>
        /// <returns>0이 반환되면 암호틀림, 1이상이면 삭제</returns>
        public int DeleteDotNetNote(int num, string password)
        {
            return (new DotNetNote.Data.DotNetNoteData()).DeleteDotNetNote(num, password); 
        }

        // 리스트용 메서드에서 매개변수와 메서드명 변경
        public List<DotNetNote.Entity.DotNetNote> SearchDotNetNote(
            string searchField, string searchQuery, int intPage)
        {
            // 리스트 제네릭 클래스 형으로 반환
            List<DotNetNote.Entity.DotNetNote> list = new List<DotNetNote.Entity.DotNetNote>();
            // DAC단 호출 : DataSet -> DataTable로 변환
            DotNetNote.Data.DotNetNoteData dnnData = new DotNetNote.Data.DotNetNoteData();
            DataTable dt = dnnData.SearchDotNetNote(searchField, searchQuery, intPage).Tables[0];
            // 데이터가 있는만큼 반복 : 최대 10개(이미 저장 프로시저에서 처리)
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                DotNetNote.Entity.DotNetNote dnn = new DotNetNote.Entity.DotNetNote();

                dnn.Num = Convert.ToInt32(dt.Rows[i]["Num"]);
                dnn.Name = dt.Rows[i]["Name"].ToString();
                dnn.Title = dt.Rows[i]["Title"].ToString();
                dnn.PostDate = Convert.ToDateTime(dt.Rows[i]["PostDate"]);
                dnn.FileName = dt.Rows[i]["FileName"].ToString();
                dnn.ReadCount = Convert.ToInt32(dt.Rows[i]["ReadCount"]);
                // 나머지 항목도 넣을 것
                dnn.Step = Convert.ToInt32(dt.Rows[i]["Step"]);

                list.Add(dnn);
            }
            // 반환
            return list;
        }


        #region 다운수 증가
        /// <summary>
        /// 다운수 증가
        /// </summary>
        /// <param name="num"></param>
        public void UpdateDownCount(int num)
        {
            // 트랜잭션 처리
            using (TransactionScope scope = new TransactionScope(TransactionScopeOption.RequiresNew))
            {
                DotNetNote.Data.DotNetNoteData dnnb = new DotNetNote.Data.DotNetNoteData();
                dnnb.UpdateDownCount(num);

                scope.Complete(); 
            }
        } 
        #endregion

    }
}
