﻿using System.Data;
using System.Data.Common;
using DotNetNote.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;

namespace DotNetNote.Data
{
    public class DotNetNoteCommentsData : DacBase
    {
        public void AddDotNetNoteComment(DotNetNote.Entity.DotNetNoteComments entity) { 
            // Database 클래스의 인스턴스 생성
            Database db = DatabaseFactory.CreateDatabase("ConnectionString"); 

            // DbCommand 클래스의 인스턴스 생성
            DbCommand dbCommand = db.GetStoredProcCommand("AddDotNetNoteComment"); 

            // 파라미터 추가
            db.AddInParameter(dbCommand, "BoardNum", DbType.Int32, entity.BoardNum);
            db.AddInParameter(dbCommand, "Name", DbType.String, entity.Name);
            db.AddInParameter(dbCommand, "Opinion", DbType.AnsiString, entity.Opinion);
            db.AddInParameter(dbCommand, "Password", DbType.String, entity.Password); 

            // 실행
            db.ExecuteNonQuery(dbCommand); 
        }
        public DataSet GetDotNetNoteComments(int num) {
            return DatabaseFactory.CreateDatabase("ConnectionString")
                .ExecuteDataSet("GetDotNetNoteComments", num);
        }
        public int DeleteDotNetNoteComment(int num, int boardNum, string password) {
            return DatabaseFactory.CreateDatabase("ConnectionString")
                .ExecuteNonQuery("DeleteDotNetNoteComment", num, boardNum, password);
        }
    }
}
