﻿using System;
using DotNetNote.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Data;

namespace DotNetNote.Data
{
    public class DotNetNoteData : DacBase
    {
        /// <summary>
        /// 데이터입력
        /// </summary>
        /// <param name="dnn">엔터티 개체</param>
        public void WriteDotNetNote(DotNetNote.Entity.DotNetNote dnn)
        {
            DatabaseFactory.CreateDatabase("ConnectionString").ExecuteNonQuery("WriteDotNetNote", dnn.Name, dnn.Email, dnn.Title, dnn.PostIP, dnn.Content, dnn.Password, dnn.Encoding, dnn.Homepage, dnn.FileName, dnn.FileSize);        
        }

        /// <summary>
        /// 리스트
        /// </summary>
        /// <param name="intPage"></param>
        /// <returns></returns>
        public System.Data.DataSet ListDotNetNote(int intPage)
        {
            return DatabaseFactory.CreateDatabase(
                "ConnectionString").ExecuteDataSet("ListDotNetNote", intPage); 
        }

        /// <summary>
        /// 레코드 카운트
        /// </summary>
        /// <returns></returns>
        public int GetCountDotNetNote()
        {
            return Convert.ToInt32(DatabaseFactory.CreateDatabase("ConnectionString")
                .ExecuteScalar(System.Data.CommandType.StoredProcedure, "GetCountDotNetNote"));
        }

        /// <summary>
        /// 검색 결과 레코드 수 반환 메서드
        /// </summary>
        public int GetCountDotNetNoteByWord(string searchField, string searchQuery)
        {
            return Convert.ToInt32(DatabaseFactory.CreateDatabase("ConnectionString")
                .ExecuteScalar("GetCountDotNetNoteByWord", searchField, searchQuery));
        }

        /// <summary>
        /// 상세
        /// </summary>
        /// <param name="num"></param>
        /// <returns></returns>
        public DataSet ViewDotNetNote(int num)
        {
            return DatabaseFactory.CreateDatabase("ConnectionString")
                .ExecuteDataSet("ViewDotNetNote", num); 
        }

        /// <summary>
        /// 답변
        /// </summary>
        /// <param name="dnn"></param>
        public void ReplyDotNetNote(DotNetNote.Entity.DotNetNote dnn)
        {
            DatabaseFactory.CreateDatabase("ConnectionString")
                .ExecuteNonQuery(
                    "ReplyDotNetNote",
                    dnn.Name,
                    dnn.Email,
                    dnn.Title,
                    dnn.PostIP,
                    dnn.Content,
                    dnn.Password,
                    dnn.Encoding,
                    dnn.Homepage,
                    dnn.ParentNum,
                    dnn.FileName,
                    dnn.FileSize
                );        
        }

        public int ModifyDotNetNote(DotNetNote.Entity.DotNetNote dnn)
        {
            int result = 0;

            result = Convert.ToInt32(DatabaseFactory.CreateDatabase("ConnectionString")
                .ExecuteScalar(
                    "ModifyDotNetNote",
                    dnn.Name, dnn.Email, dnn.Title, dnn.ModifyIP, dnn.Content, dnn.Password,
                    dnn.Encoding, dnn.Homepage, dnn.Num
                 )); 

            return result; 
        }


        /// <summary>
        /// 삭제
        /// </summary>
        /// <returns>0이 반환되면 암호틀림, 1이상이면 삭제</returns>
        public int DeleteDotNetNote(int num, string password)
        {
            return DatabaseFactory.CreateDatabase("ConnectionString")
                .ExecuteNonQuery("DeleteDotNetNote", num, password);
        }

        /// <summary>
        /// 검색
        /// </summary>
        public DataSet SearchDotNetNote(string searchField, string searchQuery, int intPage)
        {
            return DatabaseFactory.CreateDatabase(
                "ConnectionString").ExecuteDataSet(
                    "SearchDotNetNote", searchField, searchQuery, intPage);
        }

        /// <summary>
        /// 다운수 증가
        /// </summary>
        /// <param name="num"></param>
        public void UpdateDownCount(int num)
        {
            DatabaseFactory.CreateDatabase("ConnectionString").ExecuteNonQuery("UpdateDownCount", num); 
        }

    }
}
