﻿using System;
using System.Web.UI.WebControls;
using System.Data;

public partial class DotNetNote_BoardList : System.Web.UI.Page
{
    #region Private/Protected/Public Member Variables
    public int intPage = 0; //[1] 현재 보여줄 페이지 번호
    public int intTotalCount = 0; // 총 레코드 갯수(글번호 순서 정렬용)
    #endregion

    protected void Page_Load(object sender, EventArgs e)
    {
        //[2] 쿼리스트링
        if (!String.IsNullOrEmpty(Request["Page"]))
        {
            intPage = Convert.ToInt32(Request["Page"]) - 1;
        }

        //[3] 우리가 만든 AdvancedPaging 컨트롤로 페이징 처리
        AdvancedPaging1.PageIndex = intPage;
        intTotalCount = (new DotNetNote.Business.DotNetNoteBiz()).GetCountDotNetNote(); ; // 총 레코드 수 필드에 보관
        AdvancedPaging1.RecordCount = intTotalCount;
        
        if (!Page.IsPostBack)
        {
            DisplayData();
        }
    }
    private void DisplayData()
    {
        DotNetNote.Business.DotNetNoteBiz dnnBiz = new DotNetNote.Business.DotNetNoteBiz();

        this.ctlBoardList.DataSource = dnnBiz.ListDotNetNote(intPage);
        this.ctlBoardList.DataBind();
    }

    protected void ctlBoardList_PageIndexChanging(object sender, System.Web.UI.WebControls.GridViewPageEventArgs e)
    {
        intPage = e.NewPageIndex; // 클릭한 페이지를 필드에 담기 : n - 1
        this.ctlBoardList.PageIndex = e.NewPageIndex; // 클릭한 페이지에 해당되는 레코드만 출력
        DisplayData(); // 다시 바인딩
    }

    #region 24시간내에 올라온 글 new 이미지 표시하기
    public string FuncNew(object strDate)
    {
        DateTime originDate = Convert.ToDateTime(strDate);

        TimeSpan objTs = DateTime.Now - originDate;
        Literal l = new Literal(); // 순수한 태그만 표현하고자할 때
        if (objTs.TotalMinutes < 1440) // 24시간
        {
            l.Text = "<img src=\"images/new.gif\">";
        }
        return l.Text;
    }
    #endregion

    #region CutString() 함수
    /// <summary>
    /// 주어진 스트링을 주어진 길이만큼만 잘라서 돌려줌. 
    /// 나머지 부분은 '...'을 붙임 (대상 문자열, 길이)
    /// </summary>
    /// <param name="strCut">잘라낼 원본 문자열</param>
    /// <param name="intChar">제한할 글자 수</param>
    /// <returns>제한된 문자열</returns>
    public string FuncCutString(object objCut, int intChar)
    {
        string strCut = objCut.ToString();
        if (strCut.Length > intChar - 3)
        {
            string strTemp = "";
            strTemp = strCut.Substring(0, intChar - 3);
            strTemp += "...";

            return strTemp;
        }
        else
        {
            return strCut;
        }
    }
    #endregion

    #region 각 글의 Step별 들여쓰기 처리
    public string FuncStep(object objStep) {
        int intStep = Convert.ToInt32(objStep);
        string strTemp = String.Empty;
        if (intStep == 0) {
            strTemp = String.Empty;
        }
        else {
            for (int i = 0; i < intStep; i++) {
                strTemp = String.Format(
                  "<img src={0} height={1} width={2}>", "images/blank.gif", "0", (intStep * 15)
                  );
            }
            strTemp += "<img src='images/re.gif'>";
        }
        return strTemp;
    }
    #endregion

    protected string FuncFileDown(object num, object fileName)
    {
        string result = "";
        if (fileName.ToString().Length > 0)
        {
            return String.Format("<a href='BoardDown.aspx?Num={0}'>{1}</a>", num,
                "<img src='images/ext_zip.gif' border='0' />");
        }
        else
        {
            result = "-"; // 첨부된 파일이 없으면...
        }
        return result;
    }
    protected void ctlBoardList_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        // 행일때에만 변경
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            // 2009-10-28
            DateTime dt1 = Convert.ToDateTime(e.Row.Cells[4].Text);
            // 오늘날짜와 DB의 날짜가 같으면...
            if (dt1.ToShortDateString() == DateTime.Now.ToShortDateString())
            {
                // 덮어쓰기
                e.Row.Cells[4].Text = dt1.ToShortTimeString(); // 시간
            }
            else
            {
                e.Row.Cells[4].Text = dt1.ToShortDateString(); // 날짜
            }
        }    
    }



    protected void btnSearch_Click(object sender, EventArgs e)
    {
        // 검색 페이지로 Field와 Query 전송
        string strQuery = String.Format("./BoardSearch.aspx?SearchField={0}&SearchQuery={1}",
          SearchField.SelectedItem.Value, SearchQuery.Text);
        Response.Redirect(strQuery);
    }

    /// <summary>
    /// 코멘트 개수를 표현하는 메서드
    /// </summary>
    /// <param name="objCommentCount">코멘트 수</param>
    /// <returns>코멘트 이미지와 함께 숫자 표시</returns>
    protected string ShowCommentCount(object objCommentCount)
    {
        string strTemp = "";
        try {
            if (Convert.ToInt32(objCommentCount) > 0) {
                strTemp = "<img src=\"images/commentcount.gif\" />";
                strTemp += "(" + objCommentCount.ToString() + ")";
            }
        }
        catch (Exception) {
            strTemp = "";
        }
        return strTemp;
    }

}
