﻿using System;

public partial class DotNetNote_BoardModify : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (String.IsNullOrEmpty(Request["Num"]))
        {
            Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "ShowError",
                "<script>alert('잘못된 요청입니다.');history.go(-l);</script>");
            Response.End(); 
        }
        else
        {
            if (!Page.IsPostBack)
            {
                DisplayData();
            }
        }
    }
    private void DisplayData()
    {
        // 상세 패턴을 사용
        int num = Convert.ToInt32(Request["Num"]);
        DotNetNote.Entity.DotNetNote dnn = (new DotNetNote.Business.DotNetNoteBiz()).ViewDotNetNote(num);
        // 각각의 컨트롤에 출력 : 제목과 내용, 기타 바인딩
        lblNum.Text = dnn.Num.ToString();
        txtName.Text = dnn.Name;
        txtEmail.Text = dnn.Email;
        txtHomepage.Text = dnn.Homepage;
        txtTitle.Text = dnn.Title;
        txtContent.Text = dnn.Content; 
        // 예전에 선택한 인코딩을 선택
        if (dnn.Encoding.ToLower() == "html")
        {
            this.lstEncoding.SelectedIndex = 1;
        }
        else if (dnn.Encoding.ToLower() == "mixed")
        {
            this.lstEncoding.SelectedIndex = 2; 
        }
    }
    protected void btnModify_Click(object sender, EventArgs e)
    {
        DotNetNote.Entity.DotNetNote dnn = new DotNetNote.Entity.DotNetNote(); // 개체 생성
        
        // 개체에 폼 값 담기
        dnn.Name = txtName.Text;
        dnn.Email = txtEmail.Text;
        dnn.Title = txtTitle.Text;
        dnn.ModifyIP = Request.ServerVariables["REMOTE_HOST"];
        dnn.Content = txtContent.Text;
        dnn.Password = txtPassword.Text;
        dnn.Encoding = lstEncoding.SelectedValue;
        dnn.Homepage = txtHomepage.Text;
        dnn.Num = Convert.ToInt32(Request["Num"]);

        // Biz단 호출 후 결과 값 받기
        int result = (new DotNetNote.Business.DotNetNoteBiz()).ModifyDotNetNote(dnn);

        if (result == 0) {
            lblError.Text = "암호가 틀립니다.";
        }
        else {
            Response.Redirect(String.Format("BoardView.aspx?Num={0}", Request.QueryString["Num"]));
        }        
    }
}
