﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

public partial class DotNetNote_BoardReply : System.Web.UI.Page
{
    #region Private Member Variables
    private string strBaseDir;//파일 업로드 폴더
    private string strFileName;//파일명 저장 필드
    private int intFileSize;//파일크기 저장 필드
    #endregion
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            DisplayData();
        }
    }
    private void DisplayData()
    {
        // 상세 패턴을 사용해서, 부모글의 제목과 내용을 표시
        int num = Convert.ToInt32(Request["Num"]);
        DotNetNote.Entity.DotNetNote dnn = 
            (new DotNetNote.Business.DotNetNoteBiz()).ViewDotNetNote(num);
        // 각각의 컨트롤에 출력 : 제목과 내용
        txtTitle.Text = "Re : " + dnn.Title;
        string strTempContent = "\n\nOn " + dnn.PostDate + ", '" + dnn.Name + "' wrote:\n";
        strTempContent += "----------";
        strTempContent += "\n>" + dnn.Content.Replace("\n", "\n>");
        strTempContent += "\n----------";
        txtContent.Text = strTempContent;
    }
    protected void btnReply_Click(object sender, EventArgs e)
    {
        //[1] 업로드
        UploadProcess(); // 업로드 처리
        //[2] 엔터티 설정
        DotNetNote.Entity.DotNetNote dnn = new DotNetNote.Entity.DotNetNote();

        //[!] 부모글의 번호값 지정
        dnn.ParentNum = Convert.ToInt32(Request.QueryString["Num"]); // BoardView.aspx에서 넘겨옴

        //[a] 폼으로부터 가져온 데이터
        dnn.Name = txtName.Text;
        dnn.Email = txtEmail.Text;
        dnn.Homepage = txtHomepage.Text;
        dnn.Title = txtTitle.Text;
        dnn.Content = txtContent.Text;
        dnn.Encoding = lstEncoding.SelectedValue;
        dnn.Password = txtPassword.Text;
        //[b] 프로세스에 의해서 만들어진 데이터
        dnn.FileName = strFileName; //
        dnn.FileSize = intFileSize; // 
        //[c] 내부적으로 계산되는 데이터
        dnn.PostIP = Request.UserHostAddress;
        //[3] 저장 완료
        DotNetNote.Business.DotNetNoteBiz dnnb = new DotNetNote.Business.DotNetNoteBiz();
        dnnb.ReplyDotNetNote(dnn);
        //[4] 마무리
        Page.ClientScript.RegisterClientScriptBlock(
            this.GetType(), "goList", "<script>alert('답변완료');location.href='BoardList.aspx';</script>");
    }
    private void UploadProcess()
    {
        // 파일 업로드 처리 시작
        strBaseDir = Server.MapPath("./MyFiles");
        if (ctlFileName.PostedFile != null) // 업로드된 파일이 있다면.
        {
            if (ctlFileName.PostedFile.FileName.Trim().Length > 0 &&
              ctlFileName.PostedFile.ContentLength > 0) // 파일크기가 0보다 클 때에만...
            {
                strFileName = // 파일명 중복처리
                  DotNetNote.Common.Utility.GetFilePath(strBaseDir,
                    Path.GetFileName(ctlFileName.PostedFile.FileName));
                intFileSize = ctlFileName.PostedFile.ContentLength; // 파일크기
                // 업로드 처리 : SaveAs() : NTFS 쓰기권한 확인
                ctlFileName.PostedFile.SaveAs(Path.Combine(strBaseDir, strFileName));
            }
        } // 파일 업로드 처리 끝
    }
}
