﻿using System;
using System.Web.UI.WebControls;

public partial class DotNetNote_BoardSearch : System.Web.UI.Page
{
    #region Private/Protected/Public Member Variables
    public int intPage; //[1] 현재 보여줄 페이지 번호
    public int intTotalCount; // 총 레코드 갯수(글번호 순서 정렬용)
    public string searchField; // 검색 필드
    public string searchQuery; // 검색어
    #endregion

    protected void Page_Load(object sender, EventArgs e)
    {
        // BoardSearch.aspx?SearchField=Name&SearchQuery=홍길동&Page=1
        searchField = Request["SearchField"];
        searchQuery = Request["SearchQuery"]; 
        //[2] 쿼리스트링
        if (!String.IsNullOrEmpty(Request["Page"]))
        {
            intPage = Convert.ToInt32(Request["Page"]) - 1;
        }

        //[3] 우리가 만든 AdvancedPaging 컨트롤로 페이징 처리
        AdvancedPaging1.PageIndex = intPage;
        AdvancedPaging1.SearchField = searchField; //
        AdvancedPaging1.SearchQuery = searchQuery; //
        intTotalCount = (new DotNetNote.Business.DotNetNoteBiz())
            .GetCountDotNetNoteByWord(searchField, searchQuery); // 총 레코드 수 필드에 보관
        AdvancedPaging1.RecordCount = intTotalCount;

        if (!Page.IsPostBack)
        {
            DisplayData();
        }
    }

    private void DisplayData()
    {
        DotNetNote.Business.DotNetNoteBiz dnnb = new DotNetNote.Business.DotNetNoteBiz();

        this.ctlBoardList.DataSource =
            dnnb.SearchDotNetNote(Request["SearchField"], Request["SearchQuery"], intPage);
        this.ctlBoardList.DataBind(); 
    }


    #region 24시간내에 올라온 글 new 이미지 표시하기
    public string FuncNew(object strDate)
    {
        DateTime originDate = Convert.ToDateTime(strDate);

        TimeSpan objTs = DateTime.Now - originDate;
        Literal l = new Literal(); // 순수한 태그만 표현하고자할 때
        if (objTs.TotalMinutes < 1440) // 24시간
        {
            l.Text = "<img src=\"images/new.gif\">";
        }
        return l.Text;
    }
    #endregion

    #region CutString() 함수
    /// <summary>
    /// 주어진 스트링을 주어진 길이만큼만 잘라서 돌려줌. 
    /// 나머지 부분은 '...'을 붙임 (대상 문자열, 길이)
    /// </summary>
    /// <param name="strCut">잘라낼 원본 문자열</param>
    /// <param name="intChar">제한할 글자 수</param>
    /// <returns>제한된 문자열</returns>
    public string FuncCutString(object objCut, int intChar)
    {
        string strCut = objCut.ToString();
        if (strCut.Length > intChar - 3)
        {
            string strTemp = "";
            strTemp = strCut.Substring(0, intChar - 3);
            strTemp += "...";

            return strTemp;
        }
        else
        {
            return strCut;
        }
    }
    #endregion

    #region 각 글의 Step별 들여쓰기 처리
    public string FuncStep(object objStep)
    {
        int intStep = Convert.ToInt32(objStep);
        string strTemp = String.Empty;
        if (intStep == 0)
        {
            strTemp = String.Empty;
        }
        else
        {
            for (int i = 0; i < intStep; i++)
            {
                strTemp = String.Format(
                  "<img src={0} height={1} width={2}>", "images/blank.gif", "0", (intStep * 15)
                  );
            }
            strTemp += "<img src='images/re.gif'>";
        }
        return strTemp;
    }
    #endregion

    protected string FuncFileDown(object num, object fileName)
    {
        string result = "";
        if (fileName.ToString().Length > 0)
        {
            return String.Format("<a href='BoardDown.aspx?Num={0}'>{1}</a>", num,
                "<img src='images/ext_zip.gif' border='0' />");
        }
        else
        {
            result = "-"; // 첨부된 파일이 없으면...
        }
        return result;
    }


}
