﻿using System;
using System.Web.UI.WebControls;

public partial class DotNetNote_BoardView : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (String.IsNullOrEmpty(Request["Num"]))
        {
            Response.Write("잘못된 요청입니다.");
            Response.End(); 
        }
        else
        {
            if (!Page.IsPostBack)
            {
                DisplayData();
            }
        }
    }

    private void DisplayData() {
        int num = Convert.ToInt32(Request["Num"]); 
        DotNetNote.Entity.DotNetNote dnn = 
            (new DotNetNote.Business.DotNetNoteBiz()).ViewDotNetNote(num);        
        // 각각의 컨트롤에 출력
        lblTitle.Text = dnn.Title;
        lblNum.Text = dnn.Num.ToString();
        lblName.Text = dnn.Name;
        lblEmail.Text = dnn.Email;
        lblHomepage.Text = dnn.Homepage;
        lblPostDate.Text = dnn.PostDate.ToString();
        lblReadCount.Text = dnn.ReadCount.ToString();
        lblPostIP.Text = dnn.PostIP;
        lblFileName.Text = dnn.FileName;
        lblDownCount.Text = (dnn.DownCount > 0) ? "(다운수 : " + dnn.DownCount.ToString() + ")" : ""; 

        // 인코딩에 따른 Content 출력 로직 적용
        string strEncoding = dnn.Encoding;
        if (strEncoding == "Text") {// Text : 소스 그대로 표현        
            lblContent.Text = dnn.Content.Replace("&", "&amp;").Replace(
                "<", "&lt;").Replace(">", "&gt;").Replace("\r\n", "<br />");
        }
        else if (strEncoding == "Mixed") {// Mixed : 엔터처리만         
            lblContent.Text = dnn.Content.Replace("\r\n", "<br />");
        }
        else {// HTML : HTML 형식으로 출력        
            lblContent.Text = dnn.Content; // 변환없음
        }
    }

    protected void btnClick_Click(object sender, EventArgs e)
    {
        Button btn = sender as Button;
        if (btn.ID == "btnReply")
        {
            Response.Redirect("BoardReply.aspx?Num=" + Request["Num"]); 
        }
        else if (btn.ID == "btnModify")
        {
            Response.Redirect("BoardModify.aspx?Num=" + Request["Num"]);
        }
        else if (btn.ID == "btnDelete")
        {
            Response.Redirect("BoardDelete.aspx?Num=" + Request["Num"]);
        }
        else
        {
            Response.Redirect("BoardList.aspx");
        }
    }
}
